/*++
"This software program is available to you under a choice of one of two
licenses.  You may choose to be licensed under either the GNU General Public
License (GPL) Version 2, June 1991, available at
http://www.fsf.org/copyleft/gpl.html, or the Intel BSD + Patent License,
the text of which follows:

"Recipient" has requested a license and Intel Corporation ("Intel") is willing
to grant a license for the software entitled InfiniBand(tm) System Software
(the "Software") being provided by Intel Corporation.

The following definitions apply to this License:

"Licensed Patents" means patent claims licensable by Intel Corporation which
are necessarily infringed by the use or sale of the Software alone or when
combined with the operating system referred to below.

"Recipient" means the party to whom Intel delivers this Software.
"Licensee" means Recipient and those third parties that receive a license to
any operating system available under the GNU Public License version 2.0 or
later.

Copyright (c) 1996-2003 Intel Corporation. All rights reserved.

The license is provided to Recipient and Recipient's Licensees under the
following terms.

Redistribution and use in source and binary forms of the Software, with or
without modification, are permitted provided that the following conditions are
met:
Redistributions of source code of the Software may retain the above copyright
notice, this list of conditions and the following disclaimer.

Redistributions in binary form of the Software may reproduce the above
copyright notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.

Neither the name of Intel Corporation nor the names of its contributors shall
be used to endorse or promote products derived from this Software without
specific prior written permission.

Intel hereby grants Recipient and Licensees a non-exclusive, worldwide,
royalty-free patent license under Licensed Patents to make, use, sell, offer
to sell, import and otherwise transfer the Software, if any, in source code
and object code form. This license shall include changes to the Software that
are error corrections or other minor changes to the Software that do not add
functionality or features when the Software is incorporated in any version of
a operating system that has been distributed under the GNU General Public
License 2.0 or later.  This patent license shall apply to the combination of
the Software and any operating system licensed under the GNU Public License
version 2.0 or later if, at the time Intel provides the Software to Recipient,
such addition of the Software to the then publicly available versions of such
operating system available under the GNU Public License version 2.0 or later
(whether in gold, beta or alpha form) causes such combination to be covered by
the Licensed Patents. The patent license shall not apply to any other
combinations which include the Software. No hardware per se is licensed
hereunder.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL INTEL OR ITS CONTRIBUTORS BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
--*/
/*
 * Abstract:
 *	This module defines
 *
 * Environment:
 *	Linux User Mode
 *
 * $Revision: 1.1 $
 */

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>

#include <complib/cl_types.h>
#include <complib/cl_device.h>
#include <complib/cl_debug.h>
#include <complib/cl_syshelper.h>
#include <complib/cl_waitobj.h>
#include <complib/cl_memory.h>


cl_status_t
cl_create_wait_object(
	IN	const boolean_t			auto_reset,
	OUT	cl_wait_obj_handle_t	*p_wait_obj_handle )
{
	cl_status_t					status = CL_SUCCESS;
	uintn_t						command;
	cl_create_wait_obj_params_t	ioctl_buf;
	uintn_t						num_bytes_returned;
	cl_dev_handle_t				device_handle;

	/*
	 * First open sysdev to get a new FD
	 */
	status = cl_open_device( SYSHELP_DEVICE_NAME, &device_handle );
	if ( status != CL_SUCCESS )
	{
		cl_msg_out( "Failed to open device %s, status (%s) \n",
							SYSHELP_DEVICE_NAME, CL_STATUS_MSG(status) );
		return status;
	}

	command = CREATE_WAIT_OBJ;
	ioctl_buf.auto_reset = auto_reset;

	status = cl_ioctl_device(device_handle,
							 command,
							 &ioctl_buf,	 /* result */
							 sizeof (cl_create_wait_obj_params_t),
							 &num_bytes_returned);

	status = (CL_SUCCESS != status) ? status : ioctl_buf.status;

	if ( status != CL_SUCCESS)
	{
		cl_msg_out("create_wait_object: failed to create waitobject(%s) \n",
							CL_STATUS_MSG(status) );
		return status;
	}

	*p_wait_obj_handle = (cl_wait_obj_handle_t)device_handle;

	return status;
}

cl_status_t
cl_wait_on_wait_object(
	IN	cl_wait_obj_handle_t	wait_obj_handle,
	IN	uint32_t				wait_u_sec )
{
	cl_status_t				status = CL_SUCCESS;
	cl_wait_ioctl_params_t	ioctl_params;
	uintn_t					command;
	cl_dev_handle_t			device_handle = (cl_dev_handle_t)wait_obj_handle;

	/* fill out the ioctl parameters */
	ioctl_params.wait_u_sec = wait_u_sec;
	ioctl_params.wait_status = CL_SUCCESS;

	command = WAITON_WAIT_OBJ;

	status = cl_ioctl_device(device_handle,
							 command,
							 &ioctl_params,
							 sizeof(cl_wait_ioctl_params_t),
							 NULL );

	if ( status != CL_SUCCESS)
	{
		cl_msg_out("wait_on_wait_object: cl_ioctl_device failed (%s) \n",
								CL_STATUS_MSG(status) );
		return status;
	}

	/*
	 * if the ioctl returned successfully, return the status
	 * of the wait
	 */

	return (ioctl_params.wait_status);
}

cl_status_t
cl_signal_wait_object(
	IN	cl_wait_obj_handle_t	wait_obj_handle )
{
	uintn_t					command;
	cl_status_t				status = CL_SUCCESS;
	void					*p_in_buf;
	cl_dev_handle_t			device_handle = (cl_dev_handle_t)wait_obj_handle;

	p_in_buf	= wait_obj_handle;

	command = TRIGGER_WAIT_OBJ;

	status = cl_ioctl_device(device_handle,
							 command,
							 &p_in_buf,
							 sizeof(p_in_buf),
							 NULL);

	if ( status != CL_SUCCESS)
	{
		cl_msg_out("trigger_wait_object: cl_ioctl_device failed (%s) \n",
							CL_STATUS_MSG(status) );
		return	status;
	}

	return status;
}

cl_status_t
cl_destroy_wait_object(
	IN	cl_wait_obj_handle_t	wait_obj_handle )
{
	cl_status_t				status = CL_SUCCESS;
	cl_dev_handle_t			device_handle = (cl_dev_handle_t)wait_obj_handle;

	cl_close_device( device_handle );

	return status;
}

cl_status_t
cl_clear_wait_object(
	IN	cl_wait_obj_handle_t	wait_obj_handle )
{
	uintn_t					command;
	cl_status_t				status = CL_SUCCESS;
	void					*p_in_buf;
	cl_dev_handle_t			device_handle = (cl_dev_handle_t)wait_obj_handle;

	p_in_buf	= wait_obj_handle;

	command = RESET_WAIT_OBJ;

	status = cl_ioctl_device(device_handle,
							 command,
							 &p_in_buf,
							 sizeof(p_in_buf),
							 NULL);

	if ( status != CL_SUCCESS)
	{
		cl_msg_out("clear_wait_object: cl_ioctl_device failed (%s) \n",
							CL_STATUS_MSG(status) );
		return	status;
	}

	return status;
}
